PUT Project/{id}
Some tooltip text!
• 13 minutes to read
• 13 minutes to read
PUT /api/v1/Project/{id}
Updates the existing ProjectEntity
NsApiSlow threshold: 2000 ms.
| Path Part | Type | Description |
|---|---|---|
| id | int32 | The ProjectEntity id to update. Required |
Query String Parameters
| Parameter Name | Type | Description |
|---|---|---|
| $select | string | Optional comma separated list of properties to include in the result. Other fields are then nulled out to reduce payload size: "Name,department,category" Default = show all fields. |
PUT /api/v1/Project/{id}?$select=name,department,category/id
Request Headers
| Parameter Name | Description |
|---|---|
| Authorization | Supports 'Basic', 'SoTicket' and 'Bearer' schemes, depending on installation type. |
| X-XSRF-TOKEN | If not using Authorization header, you must provide XSRF value from cookie or hidden input field |
| Content-Type | Content-type of the request body: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded, application/json-patch+json, application/merge-patch+json |
| Accept | Content-type(s) you would like the response in: application/json, text/json, application/xml, text/xml, application/json-patch+json, application/merge-patch+json |
| Accept-Language | Convert string references and multi-language values into a specified language (iso2) code. |
| SO-Language | Convert string references and multi-language values into a specified language (iso2) code. Overrides Accept-Language value. |
| SO-Culture | Number, date formatting in a specified culture (iso2 language) code. Partially overrides SO-Language/Accept-Language value. Ignored if no Language set. |
| SO-TimeZone | Specify the timezone code that you would like date/time responses converted to. |
| SO-AppToken | The application token that identifies the partner app. Used when calling Online WebAPI from a server. |
Request Body: entity
The ProjectEntity to be saved.
| Property Name | Type | Description |
|---|---|---|
| ProjectId | Integer | Primary key |
| Name | String | Project name |
| ProjectNumber | String | Automatically generated number |
| ProjectMembers | Array | The persons which are members of the project |
| Urls | Array | The project's internet adresses |
| CreatedDate | String | Registered date in UTC. |
| UpdatedDate | String | Last updated date in UTC. |
| Description | String | The actual text, max 2047 significant characters even though it is stored as a larger data type on some databases |
| Postit | String | The actual text, max 2047 significant characters even though it is stored as a larger data type on some databases |
| CreatedBy | Associate | The person that created the project |
| UpdatedBy | Associate | The person that last updated the project |
| Associate | Associate | The person that created the project |
| ProjectStatus | ProjectStatus | Project status is a list defined by the database administrator. Different statuses of a project may be: “In planning”, “Started”, “Finished” and so on |
| ProjectType | ProjectType | Project type is a list defined by the database admin. for example: 'Large', 'Small', 'Party'... |
| HasImage | Boolean | True if the project has an image. (This is the image that is displayed in the CRM client) |
| ImageDescription | String | Description of the project image if it exists. (This is the image that is displayed in the CRM client) |
| ActiveStatusMonitorId | Integer | Active status monitor identity with the lowest rank for project |
| Links | Array | List of all elements linked to the project |
| ActiveLinks | Integer | Number of active links to documents, other appointments, and such |
| Completed | Boolean | Done (0=false, 1=true). Status implies changes in which fields are shown in GUI, as well as which fields can be updated |
| NextMilestoneDate | String | Calculated date, reflects date of closest non-complete future milestone activity |
| NmdAppointmentId | Integer | ID of appointment that "caused" the nextMilestoneDate, can be 0 |
| EndDate | String | Planned end date for project, inhertied from type and later editable |
| ActiveErpLinks | Integer | The number of active erp links |
| UserDefinedFields | Object | Deprecated: Use {SuperOffice.CRM.Services.ProjectEntity.CustomFields} instead. Dictionary of user defined field data. The key string is the ProgId of the UdefField, or if the ProgId is empty it is a string of the format "SuperOffice:[UdefFieldIdentity]", e.g. "SuperOffice:1234" |
| ExtraFields | Object | Deprecated: Use {SuperOffice.CRM.Services.ProjectEntity.CustomFields} instead. Extra fields added to the carrier. This could be data from Plug-ins, the foreign key system, external applications, etc. |
| CustomFields | Object | Udef + Extra fields added to the carrier. Extra fields as defined by changes to database schema + user-defined fields as defined by admin. Custom fields combines user defined fields and extra fields into one bucket. The individual {SuperOffice.CRM.Services.ProjectEntity.ExtraFields} and |
| PublishEventDate | String | Publish event date |
| PublishTo | String | Publication valid to (inclusive) |
| PublishFrom | String | Publication valid from (inclusive) |
| IsPublished | Boolean | Publication is published |
Response:
ProjectEntity updated.
| Response | Description |
|---|---|
| 200 | ProjectEntity updated. |
| 412 | Update stopped because ProjectEntity has changed since the requested If-Unmodified-Since timestamp. |
| 400 | Bad request. Entity to save is not in request body. |
Response body: ProjectEntityWithLinks
| Property Name | Type | Description |
|---|---|---|
| ProjectId | int32 | Primary key |
| Name | string | Project name |
| ProjectNumber | string | Automatically generated number |
| ProjectMembers | array | The persons which are members of the project |
| Urls | array | The project's internet adresses |
| CreatedDate | date-time | Registered date in UTC. |
| UpdatedDate | date-time | Last updated date in UTC. |
| Description | string | The actual text, max 2047 significant characters even though it is stored as a larger data type on some databases |
| Postit | string | The actual text, max 2047 significant characters even though it is stored as a larger data type on some databases |
| CreatedBy | Associate | The person that created the project |
| UpdatedBy | Associate | The person that last updated the project |
| Associate | Associate | The person that created the project Use MDO List name "associate" to get list items. |
| ProjectStatus | ProjectStatus | Project status is a list defined by the database administrator. Different statuses of a project may be: “In planning”, “Started”, “Finished” and so on Use MDO List name "projectstatus" to get list items. |
| ProjectType | ProjectType | Project type is a list defined by the database admin. for example: 'Large', 'Small', 'Party'... Use MDO List name "projecttype" to get list items. |
| HasImage | bool | True if the project has an image. (This is the image that is displayed in the CRM client) |
| ImageDescription | string | Description of the project image if it exists. (This is the image that is displayed in the CRM client) |
| ActiveStatusMonitorId | int32 | Active status monitor identity with the lowest rank for project |
| Links | array | List of all elements linked to the project |
| ActiveLinks | int32 | Number of active links to documents, other appointments, and such |
| Completed | bool | Done (0=false, 1=true). Status implies changes in which fields are shown in GUI, as well as which fields can be updated |
| NextMilestoneDate | date-time | Calculated date, reflects date of closest non-complete future milestone activity |
| NmdAppointmentId | int32 | ID of appointment that "caused" the nextMilestoneDate, can be 0 |
| EndDate | date-time | Planned end date for project, inhertied from type and later editable |
| ActiveErpLinks | int32 | The number of active erp links |
| UserDefinedFields | object | Deprecated: Use {SuperOffice.CRM.Services.ProjectEntity.CustomFields} instead. Dictionary of user defined field data. The key string is the ProgId of the UdefField, or if the ProgId is empty it is a string of the format "SuperOffice:[UdefFieldIdentity]", e.g. "SuperOffice:1234" |
| ExtraFields | object | Deprecated: Use {SuperOffice.CRM.Services.ProjectEntity.CustomFields} instead. Extra fields added to the carrier. This could be data from Plug-ins, the foreign key system, external applications, etc. |
| CustomFields | object | Udef + Extra fields added to the carrier. Extra fields as defined by changes to database schema + user-defined fields as defined by admin. Custom fields combines user defined fields and extra fields into one bucket. The individual {SuperOffice.CRM.Services.ProjectEntity.ExtraFields} and UserDefinedFields properties are deprecated in favor of this combined collection. |
| PublishEventDate | date-time | Publish event date |
| PublishTo | date-time | Publication valid to (inclusive) |
| PublishFrom | date-time | Publication valid from (inclusive) |
| IsPublished | bool | Publication is published |
| TableRight | TableRight | The carrier's table right |
| FieldProperties | object | Field property dictionary mapping field names to field access rights. |
| _Links | object |
Sample request
PUT /api/v1/Project/{id}
Authorization: Basic dGplMDpUamUw
Accept: application/json; charset=utf-8
Accept-Language: en
Content-Type: application/json; charset=utf-8
{
"ProjectId": 200,
"Name": "Hessel-Strosin",
"ProjectNumber": "371173",
"ProjectMembers": [
{
"ProjectmemberId": 52,
"ContactId": 753,
"ProjectId": 594,
"ContactName": "Legros-Frami",
"ContactDepartment": "",
"ProjectName": "Gerlach, Kerluke and Cassin",
"EmailId": 909,
"EmailAddress": "randy@reichert.co.uk",
"CountryId": 939,
"Firstname": "Oswald",
"MiddleName": "Kozey, Keebler and Volkman",
"Lastname": "Batz",
"PersonId": 627,
"Mrmrs": "odit",
"ProjectMemberTypeName": "Ferry, Bergnaum and Erdman",
"Phone": "1-581-353-0809 x82961",
"PhoneId": 897,
"ProjectMemberTypeId": 230,
"EmailAddressName": "giovanna@kerluke.uk",
"Comment": "vitae",
"FullName": "Dr. Abdiel Hand DDS",
"Registered": "2004-08-24T14:34:02.1900489+02:00",
"Updated": "2024-07-24T14:34:02.1900489+02:00"
}
],
"Urls": [
{
"Value": "rerum",
"StrippedValue": "exercitationem",
"Description": "Multi-tiered static secured line"
},
{
"Value": "rerum",
"StrippedValue": "exercitationem",
"Description": "Multi-tiered static secured line"
}
],
"CreatedDate": "2004-03-09T14:34:02.1900489+01:00",
"UpdatedDate": "2023-02-06T14:34:02.1900489+01:00",
"Description": "Upgradable value-added core",
"Postit": "quae",
"CreatedBy": null,
"UpdatedBy": null,
"Associate": null,
"ProjectStatus": null,
"ProjectType": null,
"HasImage": false,
"ImageDescription": "Organized multi-state success",
"ActiveStatusMonitorId": 66,
"Links": [
{
"EntityName": "Weber Group",
"Id": 842,
"Description": "Vision-oriented human-resource model",
"ExtraInfo": "neque",
"LinkId": 377
},
{
"EntityName": "Weber Group",
"Id": 842,
"Description": "Vision-oriented human-resource model",
"ExtraInfo": "neque",
"LinkId": 377
}
],
"ActiveLinks": 989,
"Completed": false,
"NextMilestoneDate": "2002-07-13T14:34:02.1900489+02:00",
"NmdAppointmentId": 122,
"EndDate": "2016-07-26T14:34:02.1900489+02:00",
"ActiveErpLinks": 588,
"UserDefinedFields": {
"SuperOffice:1": "Jaquelin Daugherty DDS",
"SuperOffice:2": "1158814250"
},
"ExtraFields": {
"ExtraFields1": "itaque",
"ExtraFields2": "adipisci"
},
"CustomFields": {
"CustomFields1": "consequatur",
"CustomFields2": "dolore"
},
"PublishEventDate": "2013-01-23T14:34:02.1900489+01:00",
"PublishTo": "2011-10-19T14:34:02.1900489+02:00",
"PublishFrom": "2018-03-03T14:34:02.1900489+01:00",
"IsPublished": true
}
Sample response
HTTP/1.1 200 ProjectEntity updated.
Content-Type: application/json; charset=utf-8
{
"ProjectId": 414,
"Name": "Website Redesign",
"ProjectNumber": "794026",
"ProjectMembers": [
{
"ProjectmemberId": 430,
"ContactId": 50,
"ProjectId": 398,
"ContactName": "Schumm, Ryan and Quitzon",
"ContactDepartment": "",
"ProjectName": "Herman-Will",
"EmailId": 357,
"EmailAddress": "rosario.jenkins@harber.co.uk",
"CountryId": 495,
"Firstname": "Amy",
"MiddleName": "Pollich, Waters and Paucek",
"Lastname": "Klein",
"PersonId": 849,
"Mrmrs": "modi",
"ProjectMemberTypeName": "Bogan Group",
"Phone": "718-498-6201",
"PhoneId": 74,
"ProjectMemberTypeId": 135,
"EmailAddressName": "edwina@kovacek.info",
"Comment": "sunt",
"FullName": "Ms. Dale Johnson",
"Registered": "2005-09-03T14:34:02.1900489+02:00",
"Updated": "2008-11-06T14:34:02.1900489+01:00",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.String",
"FieldLength": 69
}
}
}
],
"Urls": [
{
"Value": "doloremque",
"StrippedValue": "doloremque",
"Description": "Profit-focused real-time parallelism",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 443
}
}
},
{
"Value": "doloremque",
"StrippedValue": "doloremque",
"Description": "Profit-focused real-time parallelism",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 443
}
}
}
],
"CreatedDate": "2003-12-04T14:34:02.1900489+01:00",
"UpdatedDate": "2021-02-10T14:34:02.1900489+01:00",
"Description": "Project implementation details",
"Postit": "ad",
"CreatedBy": null,
"UpdatedBy": null,
"Associate": null,
"ProjectStatus": null,
"ProjectType": null,
"HasImage": false,
"ImageDescription": "Versatile dynamic ability",
"ActiveStatusMonitorId": 102,
"Links": [
{
"EntityName": "Grimes Inc and Sons",
"Id": 871,
"Description": "Project implementation details",
"ExtraInfo": "vitae",
"LinkId": 53,
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.String",
"FieldLength": 721
}
}
}
],
"ActiveLinks": 368,
"Completed": true,
"NextMilestoneDate": "2000-05-06T14:34:02.1900489+02:00",
"NmdAppointmentId": 186,
"EndDate": "1998-12-09T14:34:02.1900489+01:00",
"ActiveErpLinks": 415,
"UserDefinedFields": {
"SuperOffice:1": "Rosemary Rau",
"SuperOffice:2": "Dena Mueller"
},
"ExtraFields": {
"ExtraFields1": "quia",
"ExtraFields2": "blanditiis"
},
"CustomFields": {
"CustomFields1": "vero",
"CustomFields2": "sequi"
},
"PublishEventDate": "2006-04-19T14:34:02.1900489+02:00",
"PublishTo": "2002-07-28T14:34:02.1900489+02:00",
"PublishFrom": "2024-06-12T14:34:02.1900489+02:00",
"IsPublished": false,
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 981
}
},
"_Links": {
"Self": "https://www.example.com/api/v1/project/321",
"Archive": "https://www.example.com/api/v1/project"
}
}